//
// $Id: Brain.h,v 1.11 1997/10/23 02:25:32 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"
#import "Version.h"

#define APP_NAME @"Empire"

#define DK_DMakeActive        @"DMakeActive"
#define DK_DefaultMap         @"DefaultMap"
#define DK_DefaultPlayer1Type @"DefaultPlayer1Type"
#define DK_DefaultPlayer2Type @"DefaultPlayer2Type"
#define DK_DefaultPlayer3Type @"DefaultPlayer3Type"
#define DK_DefaultPlayer1Name @"DefaultPlayer1Name"
#define DK_DefaultPlayer2Name @"DefaultPlayer2Name"
#define DK_DefaultPlayer3Name @"DefaultPlayer3Name"
#define DK_MapWidth           @"MapWidth"
#define DK_MapHeight          @"MapHeight"
#define DK_CombatEventDelay   @"CombatEventDelay"
#define DK_DebugCombatEvents  @"DebugCombatEvents"
#define DK_SeedRandom         @"SeedRandom"

@class ClientController;
@class EditorController;
@class GameManager;
@class NewGameController;
@class ServerController;

//======================================================================

@interface Brain : NSObject
{
    IBOutlet NSWindow *infoPanel;
    IBOutlet NSTextField *versionTextfield;
    EditorController *editorController;

    NewGameController *newGameController;

    ServerController *serverController;
    ClientController *clientController;

    NSUserDefaults *userDefaults;

    NSMutableArray *empirePlayerBundles;
}

+ (void) initialize;
+ (Brain *) instance;
- init;
- (void) dealloc;

//======================================================================
// Interface Management
//======================================================================

- (void) showInfoPanel:sender;
- (void) newGame:sender;
- (void) startServer:sender;
- (void) startClient:sender;

- (void) newMap:sender;
- (void) open:sender;

- (NewGameController *) newGameController;
- (ServerController *) serverController;

- (BOOL) validateMenuItem:(NSMenuItem *)menuCell;

// Other:

- (void) loadEmpirePlayerBundles;
- (NSArray *) empirePlayerBundles;

- (void) bundleLoaded:(NSNotification *)aNotification;

//======================================================================
// Application Delegate
//======================================================================

- (void) applicationDidFinishLaunching:(NSNotification *)notification;

//======================================================================
// GameManager first responder chaining
//======================================================================

- (void) toggleBerserk:sender;
- (void) showCrystalBall:sender;
- (void) stopGame:sender;

@end
