//
// $Id: ClientController.h,v 1.6 1997/10/23 02:25:34 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//


#import <AppKit/AppKit.h>
#import <Foundation/NSConnection.h>
#import <Foundation/NSDistantObject.h>
#import "Empire.h"
#import "EmpireProtocols.h"

@class Brain;
@class DistributedGameManager;

@interface ClientController : NSObject <EmpireClientConnectionProtocol>
{
    IBOutlet NSWindow *clientWindow;

    IBOutlet NSTextField *serverHostTextfield;
    IBOutlet NSTextField *statusTextfield;

    IBOutlet NSTextView *messageText;

    Brain *brain;
    NSConnection *serverConnection;
    id empireServer;
}

- (void) awakeFromNib;

- initWithBrain:(Brain *)theBrain;
- (void) dealloc;

- (void) showPanel;

- (void) connectAction:sender;
- (void) disconnectAction:sender;

- (void) showText:(NSString *)format, ...;

- (void) connectionDidDie:(NSNotification *)notification;

//======================================================================
// EmpireClientConnectionProtocol
//======================================================================

- (void) ping;
- (void) aboutToDisconnect:sender;
- (void) choosePlayer:(Player)number forMap:(Map *)worldMap master:masterGameManager;

@end
