//
// $Id: CombatEvent.h,v 1.5 1997/10/23 02:25:35 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"

typedef enum _CombatEventType {
    cet_update1,
    cet_update3,
    cet_explosions,
    cet_strip_icons
} CombatEventType;

@class Map;
@class MapView;

//======================================================================

@interface CombatEvent : NSObject
{
    CombatEventType combatEventType;
    EMMapLocation eventLocation;
    MapToken tokens[9];
    int explosionCount;
    Player player;
}

+ updateAtLocation:(EMMapLocation)target ofMap:(Map *)map;
+ update3x3AroundLocation:(EMMapLocation)target ofMap:(Map *)map;
+ showExplosions:(int)count atLocation:(EMMapLocation)target;
+ stripIconsOfPlayer:(Player)number;
    
- initUpdateAtLocation:(EMMapLocation)target ofMap:(Map *)map;
- initUpdate3x3AroundLocation:(EMMapLocation)target ofMap:(Map *)map;
- initShowExplosions:(int)count atLocation:(EMMapLocation)target;
- initStripIconsOfPlayer:(Player)number;

- (void) replayCombatFor:(Map *)map in:(MapView *)mapView;

- (NSString *) description;

@end
