//
// $Id: EmpireImageVendor.h,v 1.5 1997/10/22 08:00:35 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>

@class Token;

@interface EmpireImageVendor : NSObject
{
    Token *unknown;
    Token *land;
    Token *water;

    Token *cityTokens[4];
    Token *onLandTokens[4][4];
    Token *onWaterTokens[4][10];
    Token *onCityTokens[4][12];

    NSImage *cityImages[4];
    NSImage *onLandImages[4][4];
    NSImage *onWaterImages[4][10];
    NSImage *onCityImages[4][12];

    NSMutableArray *observers;
}

+ (void) initialize;
+ (void) loadClassImages;
+ instance;

- initWithColors:(NSColor *)color1:(NSColor *)color2:(NSColor *)color3;
- (void) dealloc;

- (NSColor *) colorForPlayer:(Player)p;
- (void) setColor:(NSColor *)aColor forPlayer:(Player)p;

- (void) recacheImagesForPlayer:(Player)p;

- (NSImage *) cursor;
- (NSImage *) directionCursor;

- (NSImage *) unknown;
- (NSImage *) land;
- (NSImage *) water;
- (NSImage *) explosion;

- (NSImage *) neutralCity;

- (void)player:(Player)aPlayer:(NSImage **)city:(NSImage ***)onLand:(NSImage ***)onWater:(NSImage ***)onCity:(NSImage ***)odd;

@end

//======================================================================

@interface EmpireImageVendor (ObserverPattern)

- (void) attach:observer;
- (void) detach:observer;
- (void) notify:(BOOL)player1:(BOOL)player2:(BOOL)player3:(BOOL)other;

@end

//======================================================================

@protocol EmpireImageVendorNotification

- (void) vendorImagesUpdated:(BOOL)player1:(BOOL)player2:(BOOL)player3:(BOOL)other;

@end
