//
// $Id: HIdleState.m,v 1.2 1997/10/31 03:38:10 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import "Empire.h"

RCSID ("$Id: HIdleState.m,v 1.2 1997/10/31 03:38:10 nygard Exp $");

#import "HIdleState.h"

#import "HInitialState.h"
#import "Human.h"
#import "MapView.h"

//======================================================================
// Wait until the beginning of the next turn.
//======================================================================

@implementation HIdleState

//======================================================================
// Subclass responsibilities
//======================================================================

- (NSString *) stateName
{
    return @"Idle";
}
  
//----------------------------------------------------------------------

- (NSString *) stateKey
{
    return HS_IDLE;
}
  
//----------------------------------------------------------------------

- (void) stateEntered:(Human *)context
{
    MapView *mapView = [context mapView];
  
    // Set cursor
    [mapView setCursorEnabled:NO];

    // Disable both buttons
    [context enableContinueButton:NO];
    [context enableEndTurnButton:NO];

    [context selectThing:nil];
}

//----------------------------------------------------------------------

- (void) beginTurn:(Human *)context
{
    [context changeState:HS_INITIAL];

    // Put makeKeyAndOrderFront: call in here rather than in Human - yourTurn:
}

//----------------------------------------------------------------------

- (void) keyDown:(Human *)context:(NSEvent *)theEvent
{
    [super keyDown:context:theEvent];
}

@end
