//
// $Id: MapPathView.m,v 1.7 1997/10/31 04:51:51 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import "Empire.h"

RCSID ("$Id: MapPathView.m,v 1.7 1997/10/31 04:51:51 nygard Exp $");

#import "MapPathView.h"
#import "PathSegment.h"

//======================================================================
// This adds the ability to show a set of paths on top of the map.
//======================================================================

@implementation MapPathView

- initWithFrame:(NSRect)frameRect
{
    [super initWithFrame:frameRect];

    pathList = nil;

    return self;
}

//----------------------------------------------------------------------

- (void) dealloc
{
    SNRelease (pathList);

    [super dealloc];
}

//----------------------------------------------------------------------

- (void) drawRect:(NSRect)rect
{
    [super drawRect:rect];

    if (pathList != nil)
    {
        NSEnumerator *enumerator = [pathList objectEnumerator];
        id object;

        PSsetgray (NSWhite);
        PSsetlinewidth (0);
        
        while (object = [enumerator nextObject])
        {
            [object drawPath];
        }

        PSstroke ();
    }
}

//----------------------------------------------------------------------

- (void) usePathList:(NSArray *)newPathList
{
    SNRelease (pathList);

    pathList = [newPathList retain];

    [self setNeedsDisplay:YES];
}

@end
