//
// $Id: PathSegment.m,v 1.6 1997/10/31 04:52:01 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import "Empire.h"

RCSID ("$Id: PathSegment.m,v 1.6 1997/10/31 04:52:01 nygard Exp $");

#import "PathSegment.h"

#import "MapView.h"

//======================================================================
// A PathSegment represents a path between two locations on the map.
// It's used to show current flight paths and patrols.
//======================================================================

#define PathSegment_VERSION 1

@implementation PathSegment

+ (void) initialize
{
    if (self == [PathSegment class])
    {
        [self setVersion:PathSegment_VERSION];
    }
}

//----------------------------------------------------------------------

- initPathFromLocation:(EMMapLocation)source toLocation:(EMMapLocation)target in:(MapView *)mapView
{
    [super init];

    p1 = [mapView getCenterPointForLocation:source];
    p2 = [mapView getCenterPointForLocation:target];

    return self;
}

//----------------------------------------------------------------------

- (void) drawPath
{
    // Assumes line width/style set.

    PSmoveto (p1.x, p1.y);
    PSlineto (p2.x, p2.y); 
}

@end
