//
// $Id: SNGraphNode.h,v 1.5 1997/10/28 02:58:17 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"

typedef enum _GraphColor
{
    c_white,
    c_gray,
    c_black
} GraphColor;

//======================================================================

@interface SNGraphNode : NSObject
{
    EMMapLocation location;

    GraphColor color;
    int distance;

    SNGraphNode *predecessor;

    int biasValue;
}

+ nodeWithLocation:(EMMapLocation)target;

- initWithLocation:(EMMapLocation)target;

- (SNGraphNode *) predecessor;
- (void) setPredecessor:(SNGraphNode *)aGraphNode;
- (GraphColor) nodeColor;
- (void) setNodeColor:(GraphColor)newColor;
- (int) distance;
- (void) setDistance:(int)newDistance;

- (EMMapLocation) nodeLocation;

- (int) biasValue;
- (void) setBiasValue:(int)bias;

- (int) compareWith:(SNGraphNode *)otherNode;

@end
