//
// $Id: StatusController.h,v 1.6 1997/10/27 06:22:06 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"

@class DistributedGameManager;
@class GameManager;

@interface StatusController : NSObject
{
    IBOutlet NSWindow *statusWindow;

    IBOutlet NSTextField *gameStateTextfield;
    IBOutlet NSTextField *currentTurnTextfield;
    IBOutlet NSTableView *playerTable;

    GameManager *gameManager;
}

+ (void) initialize;

- initWithGameManager:(GameManager *)theGameManager;
- (void) dealloc;

- (void) showPanel;

- (void) stopGame:sender;

- (void) updateCurrentTurn;
- (void) updateGameStatus;
- (void) updatePlayerTable;

- (BOOL) validateMenuItem:(NSMenuItem *)menuCell;

//======================================================================
// NSTable Data Source
//======================================================================

- (int) numberOfRowsInTableView:(NSTableView *)aTableView;
- tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

@end
