//
// $Id: WarReportController.h,v 1.6 1997/10/23 05:18:42 nygard Exp $
//

//
//  This file is a part of Empire, a game of exploration and conquest.
//  Copyright (C) 1996  Steve Nygard
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  You may contact the author by:
//     e-mail:  nygard@telusplanet.net
//

#import <AppKit/AppKit.h>
#import "Empire.h"

@class EmPlayer;

@interface WarReportController : NSObject
{
    IBOutlet NSWindow *warReportWindow;

    IBOutlet NSButton *cityButton;
    IBOutlet NSMatrix *unitImageMatrix;

    IBOutlet NSTextField *cityCountText;
    IBOutlet NSTextField *cityTotalCountText;
    IBOutlet NSTextField *percentExploredText;

    IBOutlet NSMatrix *underConstructionMatrix;
    IBOutlet NSMatrix *soonestCompleteMatrix;
    IBOutlet NSMatrix *inCombatMatrix;
    IBOutlet NSMatrix *destroyedMatrix;
    IBOutlet NSMatrix *lostMatrix;

    Player lastPlayer;
}

+ (void) initialize;

- (void) awakeFromNib;
- (void) dealloc;

- (void) warReportForPlayer:(EmPlayer *)player;
- (void) setPlayer:(Player)playerNumber;

- (void) vendorImagesUpdated:(BOOL)player1:(BOOL)player2:(BOOL)player3:(BOOL)other;

- (void) warReportStopAction:sender;

@end
